#lang racket

; empty
; '()

; (list (+ 0 1) (+ 0 1 2) (+ 0 1 2 3))
; '(1 3 6)
; (list)
; '()

(define x (list (+ 0 1) (+ 0 1 2) (+ 0 1 2 3)))
; (cons 0 x)
; '(0 1 3 6)

;; (cons 1
;;   (cons 2
;;     (cons 3
;;       (cons 4 empty))))
; '(1 2 3 4)

;; (cons 4
;; (cons 3
;; (cons 2
;;  (cons 1 empty))))
;; '(4 3 2 1)

;; (empty? empty)
;; ; #t
;; (empty? (list))
;; ; #t
;; (empty? (cons 1 empty))
;; ; #f
;; (empty? (list 1))
;; ; #f


;; (first (cons 3 x))
; 3

; (first empty)
; error!

; x
; (rest (cons 3 x))
(define (flip elems)
  ; '(a b c ...)
  ; '(b a c ...)

;; Version 1
  (define a (first elems)) ; 'a
  (define tmp1 (rest elems)) ; '(b c ...)
  (define b (first tmp1)) ; 'b
  (define c (rest tmp1)) ; '(c ...)
  (cons b (cons a c))

;; Version 2
;;   (cons (first (rest elems))
;;     (cons (first elems)
;;       (rest (rest elems))))

;; Version 3
;;   (define a (first elems)) ; 'a
;;   (define tmp1 (rest elems)) ; '(b c ...)
;;   (define b (second elems)) ; 'b
;;   (define c (rest tmp1)) ; '(c ...)
;;   (cons b (cons a c))

;; Version 4
;;   (match elems
;;     [(list a b c ...)  (cons b (cons a c))]
;;   )
)

;; (flip (list 1 2 3))
;; (list 2 1 3)
;;
;; (flip (list 1 2))
;; '(2 1)

; p.getX(); camelCase
; p.get_x() ; snake_style
; get-x ; kebab-style

(define (point x y z)
  (list x y z))

(define (point? v)
; Version 1
  (and
    (list? v)
    (equal? (length v) 3)
  )
; Version 2
;;   (match v
;;     [(list x y z) #t]
;;     [_ #f])
)
#|
(point? #f)
(point? (point 1 2 3))
(point? (list 1 2))|#

(define (point-x p)
  ; (first p)
  (match p
    [(list x y z) x]
  ))
(point-x (point 1 2 3))

(define (point-y p)
  (second p))
(define (point-z p)
  (third p))


; (list 1 2 3)

(define code (quote
    (define (point-z p)
    (third p))
  )
)
(first code)
"define"
'define
(quote define)
(list 'lambda (list 'x) 'x)
(quote (lambda (x) x))
(quote (cond [(> 10 x) x] [else #f]))

(quote (list (+ 0 1) (+ 0 1 2) (+ 0 1 2 3)))









